#version 440

layout(std140) uniform Matrices{

	mat4 projMatrix;
	mat4 viewMatrix;
	mat4 modelMatrix;
};

layout(std140) uniform PreviousMatrices{

	mat4 prevProjMatrix;
	mat4 prevViewMatrix;
	mat4 prevModelMatrix;
};

in vec3 position;
in vec3 normal;
in vec2 uvPosition;

out vec3 fragVert;
out vec2 fragTexCoord;
out vec3 fragNormal;

void main()
{
	fragTexCoord = uvPosition;
	fragNormal = normal;
	fragVert = position;
	gl_Position = projMatrix  * viewMatrix * modelMatrix * vec4(position, 1);

}