#version 400

in vec3 pos_eye;
in vec3 n_eye;
//// version 1.0
//uniform samplerCube cube_texture;
// version 2.0
uniform samplerCube tex_cubemap;

layout(std140) uniform Matrices {

	mat4 projMatrix;
	mat4 viewMatrix;
	mat4 modelMatrix;
	mat4 modelViewMatrix;
	mat4 modelViewProjectionMatrix;
};

uniform mat4 V; // view matrix
out vec4 frag_colour;

void main() {
  /* reflect ray around normal from eye to surface */
  vec3 incident_eye = normalize(pos_eye);
  vec3 normal_eye = normalize(n_eye);

  vec3 reflected = reflect(incident_eye, normal_eye);
  // convert from eye to world space
  reflected = vec3(inverse(viewMatrix) * vec4(reflected, 0.0));

  frag_colour = texture(tex_cubemap, reflected);
}