#version 400

//// version 1.0
//in vec3 vp; // positions from mesh
//in vec3 vn; // normals from mesh
//uniform mat4 P, V, M; // proj, view, model matrices

// version 2.0
in vec3 position;
in vec3 normal;
layout(std140) uniform Matrices {

	mat4 projMatrix;
	mat4 viewMatrix;
	mat4 modelMatrix;
	mat4 modelViewMatrix;
	mat4 modelViewProjectionMatrix;
};

out vec3 pos_eye;
out vec3 n_eye;

void main() {
  pos_eye = vec3(viewMatrix * modelMatrix * vec4(position, 1.0));
  n_eye = vec3(viewMatrix * modelMatrix * vec4(normal, 0.0));
  gl_Position = projMatrix * viewMatrix * modelMatrix * vec4(position, 1.0);
}