#version 400

in vec3 pos_eye;
in vec3 n_eye;
in vec3 center_sphere_eye;

uniform samplerCube tex_cubemap;

layout(std140) uniform Matrices {

	mat4 projMatrix;
	mat4 viewMatrix;
	mat4 modelMatrix;
	mat4 modelViewMatrix;
	mat4 modelViewProjectionMatrix;
};

layout(std140) uniform Sphere {
	vec3 center_sphere;
	float radius_sphere;
	float refractionIndex;
};

out vec4 frag_colour;

/*
vec3 MyRefraction(vec3 incident_eye, vec3 normal_eye, float value_norm)
{
	vec3 axis_z = normal_eye;
	vec3 axis_x = cross(incident_eye, axis_z);
	vec3 axis_y = cross(axis_z, axis_x);

	// make ONB  
	mat3 base(axis_x, axis_y, axis_z);

	// make rotation matrix
	mat3 rotX;

	return base * rotX * incident_eye;

}
*/
float LookupRefractionIndex(float value_norm)
{
	return refractionIndex;
	//return refractionIndex * (1.0f - value_norm);
}

void main() {
 
   /* refract ray around normal from eye to surface */
  vec3 incident_eye = normalize(pos_eye);
  vec3 normal_eye = normalize(n_eye);

  // ----------------------------------------------------
  /*
  // refraction
  float ratio = 1.0 /1.3333;
  //float ratio = 1.3333;
  vec3 refracted = refract(incident_eye, normal_eye, ratio);
  // convert from eye to world space
  refracted = vec3(inverse(viewMatrix) * vec4(refracted, 0.0));
  frag_colour = texture(tex_cubemap, refracted);
  */
  // ----------------------------------------------------
  /*
  // refraction
  // ProjectPointOnPlane
  vec3 pos_proj_eye = vec3(pos_eye.x, pos_eye.y, 0.0);
  // GetPercentageRadius
  vec3 c_sphere_eye = vec3(center_sphere_eye.x, center_sphere_eye.y, 0.0);
  vec3 delta = c_sphere_eye - pos_proj_eye;
  float length = length(delta);
  float value_norm = min(1.0, length / radius_sphere);
  // LookupRefractionIndex
  float ratio = LookupRefractionIndex(value_norm);
  
  vec3 refracted = refract(incident_eye, normal_eye, ratio);
  // convert from eye to world space
  refracted = vec3(inverse(viewMatrix) * vec4(refracted, 0.0));
  frag_colour = texture(tex_cubemap, refracted);
  */
  // ----------------------------------------------------
  
  // refraction
  //float ratio = 1.0 /1.3333;
  float ratio = 1.0 /1.85;
  vec3 ray_ref1_eye = refract(incident_eye, normal_eye, ratio);
  float b = dot(-normal_eye, ray_ref1_eye);
  vec3 center_eye = pos_eye - normal_eye;
  vec3 pos2_eye = pos_eye + ray_ref1_eye * 2.0 * b;
  vec3 normal2_eye = pos2_eye - center_eye;
  vec3 norm2_eye = normalize(-normal2_eye);
  vec3 ray_ref2_eye = refract(ray_ref1_eye, norm2_eye, 1.0 / ratio);
  
  // convert from eye to world space
  vec3 refracted = vec3(inverse(viewMatrix) * vec4(ray_ref2_eye, 0.0));
  frag_colour = texture(tex_cubemap, refracted);
  
}