#version 410 core

//// version 1.0
//uniform mat4 mv_matrix;
//uniform mat4 proj_matrix;

// version 2.0
layout(std140) uniform Matrices {

	mat4 projMatrix;
	mat4 viewMatrix;
	mat4 modelMatrix;
	mat4 modelViewMatrix;
	mat4 modelViewProjectionMatrix;
};

layout (location = 0) in vec4 position;
layout (location = 1) in vec3 normal;

out VS_OUT
{
    vec3 normal;
    vec3 view;
} vs_out;

void main(void)
{
	//// version 1.0
	//// ----------------------------------------------------
    //vec4 pos_vs = mv_matrix * position;

    //vs_out.normal = mat3(mv_matrix) * normal;
    //vs_out.view = pos_vs.xyz;

    //gl_Position = proj_matrix * pos_vs;
	//// ----------------------------------------------------

	// version 2.0
	// ----------------------------------------------------
	//modelViewMatrix = viewMatrix * modelMatrix; // TODO: check order
	mat4 modelViewMat = viewMatrix * modelMatrix; // TODO: check order

	vec4 pos_vs = modelViewMat * position;

	vs_out.normal = mat3(modelViewMat) * normal;
	vs_out.view = pos_vs.xyz;

	gl_Position = projMatrix * pos_vs;
	// ----------------------------------------------------

}
