#version 410 core

out VS_OUT
{
    vec3    tc;
} vs_out;

//// version 1.0
//uniform mat4 view_matrix;

// version 2.0
layout(std140) uniform Matrices {

	mat4 projMatrix;
	mat4 viewMatrix;
	mat4 modelMatrix;
	mat4 modelViewMatrix;
	mat4 modelViewProjectionMatrix;
};

void main(void)
{
	//// version 1.0
	//// --------------------------------------------------------
 //   vec3[4] vertices = vec3[4](vec3(-1.0, -1.0, 1.0),
 //                              vec3( 1.0, -1.0, 1.0),
 //                              vec3(-1.0,  1.0, 1.0),
 //                              vec3( 1.0,  1.0, 1.0));

 //   vs_out.tc = mat3(view_matrix) * vertices[gl_VertexID];

 //   gl_Position = vec4(vertices[gl_VertexID], 1.0);
	//// --------------------------------------------------------

	// version 2.0
	// --------------------------------------------------------
	vec3[4] vertices = vec3[4](vec3(-1.0, -1.0, 1.0),
		vec3(1.0, -1.0, 1.0),
		vec3(-1.0, 1.0, 1.0),
		vec3(1.0, 1.0, 1.0));

	vs_out.tc = mat3(viewMatrix) * vertices[gl_VertexID];

	gl_Position = vec4(vertices[gl_VertexID], 1.0);
	// --------------------------------------------------------

}
