
//shadertype=glsl
#version 330 core
in vec3 vertexPosition_modelspace;
//uniform mat4 MVP;
 // Notice that the "1" here equals the "1" in glVertexAttribPointer
layout(location = 1) in vec3 vertexColor;
out vec3 fragmentColor;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

void main(){
 
    // Output position of the vertex, in clip space : MVP * position
    vec4 v = vec4(vertexPosition_modelspace,1); // Transform an homogeneous 4D vector, remember ?
    gl_Position =   projectionMatrix  * viewMatrix * modelMatrix * vec4(vertexPosition_modelspace, 1);

    // The color of each vertex will be interpolated
    // to produce the color of each fragment
    fragmentColor = vertexPosition_modelspace;
}