#version 330

//http://www.tomdalling.com/blog/modern-opengl/06-diffuse-point-lighting/

layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 uvPosition;
layout(location = 2) in vec3 normal;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

out vec3 fragVert;
out vec2 fragTexCoord;
out vec3 fragNormal;

void main(){
 
    fragTexCoord = uvPosition;
    fragNormal = normal;
    fragVert = vertexPosition_modelspace;

    vec4 v = vec4(vertexPosition_modelspace,1); // Transform an homogeneous 4D vector, remember ?
    gl_Position =   projectionMatrix  * viewMatrix * modelMatrix * vec4(vertexPosition_modelspace, 1);


}